#include <Message.h>
#include "thermistor.h"
#include "Hhearth.h"


#define adcPinTemperature 5
#define nbMeasuresOfADC 1000 //nb of measured averaged int temperature measurement
#define pinRelay 5

Message message;

void setup()
{
delay(500);
Serial.begin(9600);           // set up Serial library at 9600 bps
//Serial.println("m for menu");

//temperature pin setup:
 pinMode(adcPinTemperature, INPUT);     

//Hhearth sensor pins setup
pinMode(voltageFlipPin1, OUTPUT);
pinMode(voltageFlipPin2, OUTPUT);
pinMode(pinRelay, OUTPUT);
pinMode(adcPinHearthHumidity, INPUT);     

}

void loop()
{
  delay(50);
  
    if (Serial.available() > 0)  
    {
    message.readMessage();
    //Serial.print("  messageIndex ");
    //Serial.println(messageIndex, DEC);
    //for (int i=0;i<nbVals;i++) 
    
    //Serial.print("nbVals in message: ");
    //Serial.println(message.nbVals(), DEC);
 
     if (message.tag(0)=='t')//ask temperature
       {
       double adc=mesureADC(adcPinTemperature,nbMeasuresOfADC);
       double temp=adc2temp(adc) ;
       Serial.print("temp ");
       Serial.println(temp, 3);
       }
     if (message.tag(0)=='h')//ask hearth humidity
       {
       Serial.print("Hhearth ");
       Serial.println(getHhearth(), 3);
       }
       
      if (message.tag(0)=='a')//ask all
       {
       double adc=mesureADC(adcPinTemperature,nbMeasuresOfADC);
       double temp=adc2temp(adc) ;
       Serial.print("temp ");
       Serial.print(temp, 3);
       Serial.print(" Hhearth ");
       Serial.println(getHhearth(), 3);
       }
    if ((message.nbVals()==1)&(message.tag(0)=='r'))// set relay on/off
       {
       if (message.val(0)==0) 
           {
           digitalWrite(pinRelay, LOW);
           Serial.println("relay set to off ");
           }
       else
           {
           digitalWrite(pinRelay, HIGH);
           Serial.println("relay set to on ");
          } 
       }
     if (message.tag(0)=='m')//ask menu
       {
       Serial.println("a: get all ");
       Serial.println("h: get hearth humidity ");
       Serial.println("t: get Temperature ");
       Serial.println("r0 or r1: set Relay off/on ");
       }
     //if (Serial.available() == 0)    Serial.println("Done");
      }

}



