
#include <Arduino.h>

#define NUMTEMPS 61
const short table[NUMTEMPS][2] = {
{	23	,	300	},
{	25	,	295	},
{	27	,	290	},
{	28	,	285	},
{	31	,	280	},
{	33	,	275	},
{	35	,	270	},
{	38	,	265	},
{	41	,	260	},
{	44	,	255	},
{	48	,	250	},
{	52	,	245	},
{	56	,	240	},
{	61	,	235	},
{	66	,	230	},
{	71	,	225	},
{	78	,	220	},
{	84	,	215	},
{	92	,	210	},
{	100	,	205	},
{	109	,	200	},
{	120	,	195	},
{	131	,	190	},
{	143	,	185	},
{	156	,	180	},
{	171	,	175	},
{	187	,	170	},
{	205	,	165	},
{	224	,	160	},
{	245	,	155	},
{	268	,	150	},
{	293	,	145	},
{	320	,	140	},
{	348	,	135	},
{	379	,	130	},
{	411	,	125	},
{	445	,	120	},
{	480	,	115	},
{	516	,	110	},
{	553	,	105	},
{	591	,	100	},
{	628	,	95	},
{	665	,	90	},
{	702	,	85	},
{	737	,	80	},
{	770	,	75	},
{	801	,	70	},
{	830	,	65	},
{	857	,	60	},
{	881	,	55	},
{	903	,	50	},
{	922	,	45	},
{	939	,	40	},
{	954	,	35	},
{	966	,	30	},
{	977	,	25	},
{	985	,	20	},
{	993	,	15	},
{	999	,	10	},
{	1004	,	5	},
{	1008	,	0	} //safety
};



double adc2temp(double raw) {
    double celsius = 0;
    int i;
    
    //raw = 1023 - raw;

    for (i=1; i<NUMTEMPS; i++)
    {
      if (table[i][0] > raw)
      {
        celsius  = table[i-1][1] + 
          (raw - table[i-1][0]) * 
          (table[i][1] - table[i-1][1]) /
          (table[i][0] - table[i-1][0]);

        break;
      }
    }

    // Overflow: Set to last value in the table
    if (i == NUMTEMPS) celsius = table[i-1][1];

    return celsius;
}



double temp2adc(double celcius) {
    double adc = 0;
    int i;
    
    //raw = 1023 - raw;

    for (i=0; i<NUMTEMPS; i++)
    {
      if (table[i][1] < celcius)
      {
        adc  = table[i-1][0] + 
          (celcius - table[i-1][1]) * 
          (table[i][0] - table[i-1][0]) /
          (table[i][1] - table[i-1][1]);

        break;
      }
    }

    // Overflow: Set to last value in the table
    if (i == NUMTEMPS) adc = table[i-1][0];

    return adc;
}





double mesureADC(int pin,int n)
{
  double m=0;
  for (int i=0;i<n;i++)
    {
    m+= analogRead(pin);  
    }
  m= m/n;
  return m;
}





